Bug 485970 - Installed libperl.so is used during build self-test
Installed libperl.so is used during build self-test
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: perl (Show other bugs)
10
All Linux
low Severity medium
: ---
: ---
Assigned To: Stepan Kasal
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-17 13:29 EST by Steve Snyder
Modified: 2009-12-18 02:56 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 02:56:43 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Steve Snyder 2009-02-17 13:29:04 EST
Description of problem:

In the course of building the binary Perl RPMs, a series of self-tests are done.  These tests should be using the newly-built libperl.so exclusively (that is the point of the tests, right?).  Instead the installed copy of the library is sometimes used during the test run.

Version-Release number of selected component (if applicable):

perl-5.10.0-53.fc10

How reproducible:

Always

Steps to Reproduce:
1. do "lsof | libperl" to verify that the installed library is not in use
2. build the binary RPM (e.g. "rpmbuild --rebuild perl-5.10.0-53.fc10.src.rpm")
3. while the self-test is running do "lsof | libperl" again.  you may see the installed lib in use

Actual results:

The installed version of the Perl shared library is used during the self-test of the version being built.

Expected results:

During the self-tests the newly-built (not the installed) copy of the shared library should be used.

Additional info:

I've seen this for many version, but I've just worked up the ambition to write it up now.

Here's another way to see that the installed Perl is used during the self test.  Build a set of Perl RPMs with PGO enabled, then install the packages.  As the binaries are used profiling data is written to the filesystem.  Now build another set of Perl RPMs.  During the self test of the 2nd set the installed lib will again have it's profiling data written to disk.  This can be considered proof that the self-tests are not always testing the code just compiled.

Or maybe the installed libperl.so can be temporarily be replaced with a lib that just causes a segfault, or something else dramatic.  That too would prove that it is not just the library under test that is being used.
Comment 1 Marcela Mašláňová 2009-02-26 09:51:37 EST
The binaries which are shipped are checked with at-the-time built libperl.so because of building in mock. So the tests should be really checking regressions in actual package.

Shouldn't this be fixed in cleaning paths in rawhide? Stepan?
Comment 2 Stepan Kasal 2009-03-30 06:57:09 EDT
(In reply to comment #1)
> The binaries which are shipped are checked with at-the-time built libperl.so
> because of building in mock.

This argument is not valid, because perl is always installed in the mock root.
Package rpm-build requires /usr/bin/perl, because several of the automated dependency generators are written in perl.  Until these are rewritten, perl will always be dragged to the build tree.
Comment 3 Bug Zapper 2009-11-18 06:07:49 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bug Zapper 2009-12-18 02:56:43 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.